/****************************************************************************************
 * KF8A系列单片机	KF8A100EON_DEMO	开发板演示程序
 * 标    题: RTC实验
 * 项目名: 11- RTC_Sample
 * 开发环境：ChipON IDE
 * 版          本     ：V1.0 (2019/07/23)
 * 作 者: 上海芯旺微电子有限公司
 * 功能简述: 使用内部RTC每秒串口打印到PC输出时、分、秒格式
 * 硬件说明： UART2引脚为P43、P44，接到TTL-USB芯片，插入USB线与PC通信
 * 跳线接法： 单片机供电跳帽选择为3.3V或5V
 ****************************************************************************************/
#include<KF8A100GQT.h>
#include "includes.h"

void delay_ms(uint16 num)
{
	uint16 i,j;
	for(i=0;i<num;i++)
	{
		j=100;
		while(j--);
	}
}

void SYS_Init(void)
{
	TR0 = 0;	TR1	= 0;	TR2	= 0;	TR3 = 0;
	TR4 = 0;	TR5 = 0;	TR6 = 0;	TR7 = 0;
	TR9 = 0;	TRA = 0;	TRB = 0;
	P0LR = 0;	P1LR = 0;	P2LR = 0;	P3LR = 0;
	P4LR = 0;	P5LR = 0;	P6LR = 0;	P7LR = 0;
	P9LR = 0;	PALR = 0;	PBLR = 0;

	BKPCTL|=0x80;				//备份区开放
	TR06=1;TR07=1;
	ANS06=1;ANS07=1;	//RTC必须使用外部晶振
	EXTLFEN=1;			//使能外部晶振

	//使用外部晶振时，引脚配置输入，配置字选择外部时钟且允许切换
	SCLKCTL = SYSYCLK_SEL_SCKS|SYSCLK_SCLK_SEL_INTHF|SYSCLK_FREQ_DIV1;	//INTHF作为主时钟
	_NOP();_NOP();	//高速时钟稳定
	PLLEN=0;
	PLLCTL = PLL_SEL_DIV1|PLL_SEL_INTHF|PLLBIAS_CUR_MIN|PLLPMUL_2;
	PLLEN=1;
	delay_ms(200);
	SCLKCTL|=SYSYCLK_SEL_SCKS|SYSCLK_SCLK_SEL_UPCK;		//UPCK作为主时钟	32M
	SCLKOE = 0;		//机器周期禁能输出,输出波形与IO翻转速率相关
	CLKOUTSEL = 0;
	HFCKCTL = 0xCE;	//外设高速时钟开启, 选择INTHF为HFCLK时钟信号
	LFCKCTL = 0x8F;	//外设低速时钟开启, 选择EXTLF为LFCLK时钟信号
}

void main()
{
	SYS_Init();
	UART2_Init();
	Timer1_Init();
	RTC_Configuration();

	//总中断开启
	AIE=1;
	PUIE=1;

	while(1)
	{

	}

}


//中断函数0:0X04入口地址
void int_fun0() __interrupt (0)
{

	if(T1IE & T1IF)
	{
		T1IF=0;
	}
	if(TTIF)	//RTC节拍中断	1S
	{
		TTIF=0;
		P9LR1=!P9LR1;
	}
}


//中断函数1:0x14入口地址
void int_fun1() __interrupt (1)
{

}
